#!/bin/bash
# Utility functions for basebox test shell scripts
#

bin_dir="../../basebox/bin"
source_dir="../../.."

#
# Run a basebox command.
#
# Assuming that if run by a customer that wants to try the demo app, we first look if there
# is an exeutable at "../../basebox/bin/$1" and run it if present.
# If not, we assume this is being run inside of a basebox developer environment and start the
# command with "cargo run".
#
function bb_run {
    command="$1"
    args="${@:2}"

    # check bin directory
    if [ -f "$bin_dir/$command" ]; then
        "$bin_dir/$command" $args
        return $?
    fi

    # check source tree
    if [ -d "$source_dir/$command" ]; then
        cargo run --manifest-path=$source_dir/$command/Cargo.toml -- $args
        return $?
    fi

    echo "Program '$command' not found!"
    return 2
}
